#include "regexp.h"

struct regexpinstance {
	int		refs;
	regexp *	r;

		regexpinstance(int n, regexp * re) {refs = n; r=re;};
		~regexpinstance() {if (r != NULL) {free(r); r=NULL;}}
};

class RegExp {
	regexpinstance *r;
public:
		RegExp(void) { r = NULL;}
		RegExp(char * source) {	
			r = new regexpinstance(1, regcomp(source));
//printf("RegExp(%s)=%08lx %d\n",source, r->r, r->refs); fflush(stdout);
			}

		RegExp(RegExp& re)     { r = re.r; r->refs++;}
	RegExp&	operator =(RegExp& re) { 
			if (r != NULL && (!r->refs || !--r->refs)) 
				delete r;
			r = re.r; r->refs++; return *this;}

		~RegExp(void) { 
//printf("~RegExp %08lx %d\n", r->r, r->refs); fflush(stdout);
			r->refs--; 
			if (r && !r->refs) 
				delete r;}

	int	valid(void) {return (r!=NULL&&r->r!=NULL);}
	int	test(char * str) {
//printf("RegExp.test %08lx <%s>\n", r->r, str);
			return regexec(r->r, str);}
	void	substr(char * str, char * repl) { regsub(r->r,str,repl);}

static void setErrorFunc( void (*func)( char*)) {
			set_regerror_func(func); }
};

